var $ = jQuery;
$(function() {

    $("div.GroupContainerAttached").show().each(function() {
        $(this).css("height", $(this).height());
    });


    var jStudentInput = $(".InputStudentName").first(); 
    var jGradeSelect = $(".SelectGrade").first(); 
    var jSGSelect = $(".SelectStudyGroup").first(); 
    var jSearchResult = $(".SearchResult").first(); 
    var jStList = $("div.AttachedStudentsList");

    var jStudentPrototype = $($.parseHTML(	"<div id='0' class='Student'>"+
                                                "<span class='Name'></span>"+
                                                "<span id='0' class='From'></span>"+
                                                "<button class='action'></button>"+
                                            "</div>"));


    var jStudentEmptyPrototype = $($.parseHTML(
    		"<p class='notification'>Нет результатов... Возможно, студенты, соответствующие критериям поиска, уже прикреплены.</p>"));

    var jGroupWrapPrototype = 	$($.parseHTML(	"<select class='SelectStudyGroup defaultForm'>\
                								<option value='0'>Выберите группу:</option>"));


    var jGroupPrototype = $($.parseHTML("<option value='0'></option>"));

    var jGroupContainerPrototype = $($.parseHTML(	"<div class='GroupContainerAttached' id='0'>\
    													<div class='groupInfo'>\
                                                            <div class = 'groupInfoAlone'></div>\
                                                        </div>\
													</div>"));



    function ConstructGroup(groupID, groupNum, specName) {
    	var jClone = jGroupPrototype.clone();
    	var str = "группа "+groupNum
    	if (specName != null) {
    		str += " - "+specName; 
    	}
    	jClone.html(str);
    	jClone.val(groupID);
    	return jClone;
    }

    function ConstructStudent(ID, name, bind) {
        var jStudent = jStudentPrototype.clone();
        var jStudentSib = jStudent.children();

        if (bind === true) {
            var status = "StatusBind";
            var actionDesc = "Отсоединить студента";
            var action = "Action_UnbindStudent";
        } else { 
            var status = "StatusUnbind";
            var actionDesc = "Прикрепить студента";
            var action = "Action_BindStudent";
        }

        jStudent.attr("id", ID);
        jStudent.addClass(status);
        jStudentSib.filter("span.Name").html(name);
        jStudentSib.filter("button.action").addClass(action).html(actionDesc);
        
        return jStudent;
    }

    function ConstructGroupContainer(GroupID, Group, Grade) {
    	var jClone = jGroupContainerPrototype.clone();
    	var text = Grade+"."+Group; 
    	jClone.attr("id", GroupID);
    	jClone.children().first().children().html(text);
    	return jClone;
    }

    function SearchStudents() {
        var temp = $(".InputStudentName").val();
        
        $.post(
            g_URLdir + "handler/map/SearchStudents",
            {
                "GradeID": jGradeSelect.val(),
                "GroupID": jSGSelect.val(),
                "FacultyID": g_facultyID,
                "Name": temp,
                "DisciplineID": g_disciplineID
            },
            function(searchResult){
                var searchResult = $.parseJSON(searchResult);
                console.log(searchResult);
                var i = -1;
                jSearchResult.html("");
                var jClone = jSearchResult.clone();

                var curGroupID = 0;
                for (i in searchResult) {
                	var student = searchResult[i]; 
                	if (student.GroupID != curGroupID) {
                		var groupID = student.GroupID;
                		var groupNum = student.GroupNum;
                		var gradeNum = student.GradeNum;
                		var jCurGroup = ConstructGroupContainer(groupID, groupNum, gradeNum);
                		curGroupID = groupID;
                		jClone.append(jCurGroup);
                	}
                    var ID = student.ID;
                    var name = student.LastName +" "+  student.FirstName +" "+ student.SecondName;
                    var jTempStudent = ConstructStudent(ID, name, false);
                    jCurGroup.append(jTempStudent);
                }

                if (searchResult.length <= 0) {
                    jSearchResult.append(jStudentEmptyPrototype.clone());
                } else {
                    jSearchResult.replaceWith(jClone);
                    jSearchResult = jClone;
                } 
            }
        ); //!post 
    }

    var typewatch = (function() {
        var timer = 0;
        return function(callback, ms) {
            clearTimeout(timer);
            timer = setTimeout(callback, ms);
        };
    })();

    var updateList = function(e) {
        typewatch(function() {
            SearchStudents();
            $(this).blur();
        }, 700);
    };

    $(".searchBtn").click(updateList);

    jStudentInput
        .keyup(updateList)
        .bind("paste", updateList);


    function GetGroups() {
        $.post(
            g_URLdir + "handler/map/GetGroups",
            {
                "FacultyID": g_facultyID,
                "GradeID": jGradeSelect.val()
            },
            function(data) {
                var i = 0;
                data = $.parseJSON(data);
                jSGSelect.html("");

                if (data != null && data != undefined) {
                    var jClone = jGroupWrapPrototype.clone(); 

                    for (i in data) {
                    	var temp = data[i];
                    	jClone.append(ConstructGroup(temp.ID, temp.GroupNum, temp.SpecName));
                    } 
                       
                    jSGSelect.replaceWith(jClone);
                    jSGSelect = jClone;
                    jSGSelect.change(function(){
                        SearchStudents();
                    });
                }
                //SearchStudents();
            } //!callback
        ); //!post      
    }

    jGradeSelect.change(function(){
        GetGroups();
    });



    // Если студент из поиска
    function BindStudentFromSearch(jThis) 
    {
    	var jThis = jThis.parent();
    	var jParent = jThis.parent();
    	var groupID = jParent.attr("id");

    	var jGroup = jStList.children("#"+groupID);
    	if (jGroup.length <= 0) {
    		jGroup = jGroupContainerPrototype.clone();
    		jGroup.attr("id", groupID);
    		var text = jParent.children().first().html();
    		jGroup.children().html(text);
    		jStList.append(jGroup);
    	}
    	console.log(jGroup.html());

        var len = jParent.children().length;
        if (len <= 1) {
        	jParent.remove();
        } else {
        	jParent.css("height", jParent.height() - 40);
        }

        jThis.removeClass()
        	.addClass("Student StatusBind");
    	var but = jThis.children("button.action");
    	but.removeClass()
    		.addClass("action Action_UnbindStudent")
    		.html("Отсоединить студента");
		jGroup.css("height", jGroup.height() + 40);
    	jGroup.append(jThis);
    }

    // Если студент из основного потока
    function BindBackStudent(jThis) {
        jThis
            .removeClass("Action_BindStudent")
            .addClass("Action_UnbindStudent")
            .text("Отсоединить студента");
        jThis
            .parent()
            .removeClass("StatusUnbind")
            .addClass("StatusBind");
    }





    // Прикрепить студента 
    $(".GeneralStudentsList").on("click", "button.Action_BindStudent", function(){
        var jThis = $(this);
        $(this).attr("disabled", true);
        var ID = $(this).parent().attr("id");
        $.post(
            URLdir + "handler/map/BindStudent",
            {
                "StudentID": ID,
                "DisciplineID": g_disciplineID
            },
            function(data){
                data = $.parseJSON(data);
                if(data.success === true) {
                    BindBackStudent(jThis);
                }
                else EventInspector.error("Ошибка при добавлении студента");
                jThis.removeAttr("disabled");
            }
        );
    });

    // Прикрепить студента из поиска
    $(".StudentsList").on("click", "button.Action_BindStudent", function(){
        var jThis = $(this);
        $(this).attr("disabled", true);
        var ID = $(this).parent().attr("id");
        $.post(
            URLdir + "handler/map/BindStudent",
            {
                "StudentID": ID,
                "DisciplineID": g_disciplineID
            },
            function(data){
                data = $.parseJSON(data);
                if(data.success === true) {
                    BindStudentFromSearch(jThis);
                    //jThis.remove();
                }
                else EventInspector.error("Ошибка при добавлении студента");
                jThis.removeAttr("disabled");
            }
        );
    });

    // Отсоединить студента 
    $(".GeneralStudentsList").on("click", "button.Action_UnbindStudent", function(){
        var jThis = $(this);
        $(this).attr("disabled", true);
        var ID = $(this).parent().attr("id");
        $.post(
            URLdir + "handler/map/UnbindStudent",
            {
                "StudentID": ID,
                "DisciplineID": g_disciplineID
            },
            function(data){
                data = $.parseJSON(data);
                if(data.success === true) {
                    jThis
                        .removeClass("Action_UnbindStudent")
                        .addClass("Action_BindStudent")
                        .text("Прикрепить студента");
                    jThis
                        .parent()
                        .removeClass("StatusBind")
                        .addClass("StatusUnbind");
                }
                else EventInspector.error("Ошибка при отсоединении студента");
                jThis.removeAttr("disabled");
            }
        );
    });


    $(".AttachedStudentsList").on("click", "button.Action_UnbindStudent", function(){
        var jThis = $(this);
        $(this).attr("disabled", true);
        var ID = $(this).parent().attr("id");
        $.post(
            URLdir + "handler/map/UnbindStudent",
            {
                "StudentID": ID,
                "DisciplineID": g_disciplineID
            },
            function(data){
                data = $.parseJSON(data);
                if(data.success === true) {
                    var jParent = jThis.parent().parent();

                    jThis.parent().remove();
                    var len = jParent.children().length;
                    if (len <= 1) {
                    	jParent.remove();
                    } else {
                    	jParent.css("height", jParent.height() - 40);
                    }
                }
                else EventInspector.error("Ошибка при отсоединении студента");
                jThis.removeAttr("disabled");
            }
        );
    });

    // Показать/скрыть список студентов
    $(".StudentsList").on("click", ".ActionShowHideGroupContainer", function(){
        var GroupContainer = $(this).next(".GroupContainer");
        if (GroupContainer.css("display") == "none") {
            $(this).children(".Action").text("Скрыть список ▲");
            GroupContainer.show();
            GroupContainer.css("height", GroupContainer.height() + 3);
        }
        else {
            $(this).children(".Action").text("Открыть список ▼");
            GroupContainer.hide("normal");
        }
    });

    $(".StudentsList").on("click", "div.hideListAction", function(){
        $(this).parent()
            .hide("normal");
            
        $(this).parent()
            .prev()
            .children(".Action")
            .text("Открыть список ▼");
    });



    // $(".GroupContainer").on("click", "button.btn_editStudents", function() { 
    //     $(this).parent().children("div").children("button.Action_UnbindStudent").each(function() {
    //         $(this).click();
    //     });
    // });



});
